Package ghidra.util.database

# Class DBBufferInputStream

java.lang.Object
java.io.InputStream
ghidra.util.database.DBBufferInputStream

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`

public class DBBufferInputStream extends InputStream
An input stream backed by a database chained buffer

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected final DBBuffer`
  `buffer`
  `protected int`
  `mark`
  `protected int`
  `offset`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DBBufferInputStream(DBBuffer buffer)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `available()`
  `void`
  `mark(int readlimit)`
  `boolean`
  `markSupported()`
  `int`
  `read()`
  `int`
  `read(byte[] b)`
  `int`
  `read(byte[] b, int off, int len)`
  `byte[]`
  `readAllBytes()`
  `int`
  `readNBytes(byte[] b, int off, int len)`
  `byte[]`
  `readNBytes(int len)`
  `void`
  `reset()`
  `long`
  `skip(long n)`

  ### Methods inherited from class java.io.InputStream

  `close, nullInputStream, skipNBytes, transferTo`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### buffer

    protected final DBBuffer buffer

  - ### offset

    protected int offset

  - ### mark

    protected int mark

- ## Constructor Details

  - ### DBBufferInputStream

    public DBBufferInputStream(DBBuffer buffer)

- ## Method Details

  - ### available

    public int available() throws IOException
    Overrides:
      `available` in class `InputStream`
    Throws:
      `IOException`

  - ### mark

    public void mark(int readlimit)
    Overrides:
      `mark` in class `InputStream`

  - ### markSupported

    public boolean markSupported()
    Overrides:
      `markSupported` in class `InputStream`

  - ### read

    public int read(byte[] b) throws IndexOutOfBoundsException, IOException
    Overrides:
      `read` in class `InputStream`
    Throws:
      `IndexOutOfBoundsException`
      `IOException`

  - ### read

    public int read(byte[] b, int off, int len) throws IndexOutOfBoundsException, IOException
    Overrides:
      `read` in class `InputStream`
    Throws:
      `IndexOutOfBoundsException`
      `IOException`

  - ### read

    public int read() throws IOException
    Specified by:
      `read` in class `InputStream`
    Throws:
      `IOException`

  - ### readAllBytes

    public byte[] readAllBytes() throws IOException
    Overrides:
      `readAllBytes` in class `InputStream`
    Throws:
      `IOException`

  - ### readNBytes

    public int readNBytes(byte[] b, int off, int len) throws IOException
    Overrides:
      `readNBytes` in class `InputStream`
    Throws:
      `IOException`

  - ### readNBytes

    public byte[] readNBytes(int len) throws IOException
    Overrides:
      `readNBytes` in class `InputStream`
    Throws:
      `IOException`

  - ### reset

    public void reset() throws IOException
    Overrides:
      `reset` in class `InputStream`
    Throws:
      `IOException`

  - ### skip

    public long skip(long n) throws IOException
    Overrides:
      `skip` in class `InputStream`
    Throws:
      `IOException`